/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: 
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jtests.clients.entity;

import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.objectweb.jonas.jtests.beans.ebasic.SimpleHome;

/**
 * These tests are about transaction isolation on CMP version 2 entity beans.
 * Only specific tests to CMP are here, all tests common to BMP and CMP
 * are in the inherited class IsolationTests.
 * @author Helene Joanin (jonas team)
 */
public class G_IsolationEC2 extends B_Isolation {

    private static String BEAN_HOME = "ebasicSimpleEC2Home";
    protected static SimpleHome home = null;

    public G_IsolationEC2(String name) {
        super(name);
    }

    public void testEmpty() throws Exception {
    }

    public SimpleHome getHome() {
        if (home == null) {
            try {
                home = (SimpleHome) PortableRemoteObject.narrow(ictx.lookup(BEAN_HOME), SimpleHome.class);
            } catch (NamingException e) {
                fail("Cannot get bean home");
            }
            // init here tables if CMP2
            try {
                home.create("pk1", 10, 4);
                home.create("pk2", 10, 4);
                home.create("pk3", 10, 4);
                home.create("pk4", 40, 8);
                home.create("pk5", 50, 8);
                home.create("pk6", 60, 8);
                home.create("pk7", 70, 8);
                home.create("pk8", 45, 20);
                home.create("pk9", 55, 30);
                home.create("pk10",80, 80);
                home.create("pk11",80, 80);
                home.create("pk12",90, 90);
                home.create("pk13",100, 90);
                home.create("pk14",110, 90);
            } catch (Exception i) {
            }
        }
        return home;
    }

    /**
     * init environment:
     * - load beans
     * - create/init database for entities.
     */
    protected void setUp() {
        super.setUp();
    }

    /**
     * This suite is all CMP test cases
     */
    public static Test suite() {
        return new TestSuite(G_IsolationEC2.class);
    }

    public static void main (String args[]) {
        String testtorun = null;
        // Get args
        for (int argn = 0; argn < args.length; argn++) {
            String s_arg = args[argn];
            Integer i_arg;
            if (s_arg.equals("-n")) {
                testtorun = args[++argn];
            }
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new G_IsolationEC2(testtorun));
        }
    }
}
